/* Copyright (C) 2009 Papavasileiou Dimitris                             
 *                                                                      
 * This program is free software: you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License as published by 
 * the Free Software Foundation, either version 3 of the License, or    
 * (at your option) any later version.                                  
 *                                                                      
 * This program is distributed in the hope that it will be useful,      
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        
 * GNU General Public License for more details.                         
 *                                                                      
 * You should have received a copy of the GNU General Public License    
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _CONVEX_H_
#define _CONVEX_H_

#include <lua.h>
#include <GL/gl.h>
#include <ode/ode.h>
#include "body.h"

@interface Convex: Body {
    dReal *planes, *points;
    unsigned int *polygons;
    int size[2];
}

-(Convex *) initWith: (int) n planes: (dReal *) reals
                 and: (int) m points: (dReal *) morereals
	 andPolygons: (unsigned int *) unsigneds;

-(int) planes;
-(int) points;

@end

#endif
