/* Copyright (C) 2009 Papavasileiou Dimitris                             
 *                                                                      
 * This program is free software: you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License as published by 
 * the Free Software Foundation, either version 3 of the License, or    
 * (at your option) any later version.                                  
 *                                                                      
 * This program is distributed in the hope that it will be useful,      
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        
 * GNU General Public License for more details.                         
 *                                                                      
 * You should have received a copy of the GNU General Public License    
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _LAND_H_
#define _LAND_H_

#include <lua.h>
#include <GL/gl.h>
#include <ode/ode.h>

#include "roam.h"
#include "node.h"

@interface Land: Node {
    int palette;
    
    GLuint program, sampler, detailSampler[7], factor;
    GLuint turbidity, sunDirection, sunColor, eccentricity;
    GLuint rayleigh, mie, power;

    GLuint *detail;
    double (*pigments)[8];

    double albedo, separation;
}

-(void) rebuildWithPalette: (int)c;

@end

#endif
